//	AcadPan (UstnPan) - MDL module for MicroStation
//	Copyright 2006 - 2014 Leonid Wiebe, All Rights Reserved.


//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.


#define _AFXDLL

#include <afxwin.h>         // MFC core and standard components
#include <afxdlgs.h>        // MFC components
#include <stdio.h>
#include <stdlib.h>

#include	"StdAfx.h"

#include    <mdl.h>	
#include    <tcb.h>	

#include    <dlogitem.h>   
#include    <cexpr.h>	 
#include    <cmdlist.h>	  
#include    <dlogids.h>

#include    <dlogman.fdf> 
#include    <msrsrc.fdf>

#include    <msparse.fdf>
#include    <msbutton.h>	
#include    <mssystem.fdf>
#include    <msselect.fdf>
#include    <msstate.fdf>
#include    <msmisc.fdf>
#include    <msinput.fdf>
#include    <msview.fdf>
#include    <mswindow.fdf>
#include    <msrmatrx.fdf>
#include    <mstmatrx.fdf>
#include    <mscexpr.fdf>
#include    <msundo.fdf>
#include    <msoutput.fdf>
#include    <buildVersion.h>

#include    <string.h>

#include	<mstxtfil.h>

#if !defined (mdl)
extern "C"
{
	//	Alias for ustnTaskId if compiling native code C or C++
	//	Link with mdlbltin.lib
	extern char*		ustnTaskIdP;
}	//	extern C
#endif


#include "acadpancmd.h"  
#include "acadpan.h"




int iDown = 0;
int iMotionCount = 0;

int iButton = -1;
int iUpdate = 0;
int iReset = 1;
int iDblClick = 1;
double dDelay = 2.;
double dDblClickTime = 0.5;
int iKeepSel = TRUE;

int iSendReset = 0;

int iFitAll = 0;
int iFitTimerOn = 0;

int iCursor = 1;


char* sName =         "ACADPAN_BUTTON";
char* sUpdate =       "ACADPAN_UPDATE";
char* sReset =        "ACADPAN_RESET";
char* sDblClick =     "ACADPAN_DCLICK";
char* sDelay =        "ACADPAN_DELAY";
char* sDblClickTime = "ACADPAN_DCTIME";

char* sNameNew =         "USTNPAN_BUTTON";
char* sUpdateNew =       "USTNPAN_UPDATE";
char* sResetNew =        "USTNPAN_RESET";
char* sDblClickNew =     "USTNPAN_DCLICK";
char* sDelayNew =        "USTNPAN_DELAY";
char* sDblClickTimeNew = "USTNPAN_DCTIME";
char* sKeepSel =         "USTNPAN_KEEPSEL";

//USTNPAN_BUTTON = -1
//USTNPAN_DELAY = 4
//USTNPAN_DCTIME = 0.00
//USTNPAN_UPDATE = 0
//USTNPAN_RESET = -1
//USTNPAN_DCLICK = 0
//USTNPAN_CURSOR = 1


int view;

int timerHandleP; // timer
int timerHandleP2; // timer



DPoint3d pCenter;
DPoint3d pScrCenter;
DPoint3d pMouse;
DPoint3d pOffset;
Point2d spCenter;
Point2d spMouse;
Point2d spOffset;

DPoint3d pDeltaX;
DPoint3d pDeltaY;


UInt32 fp_sel = 0;

HCURSOR hCurs2 = NULL;             // cursor handle 
HCURSOR hCurs3 = NULL;             // cursor handle 
/*
BYTE ANDmaskCursor[] = 
{ 
	0xF0, 0xFF,   // 
	0xC0, 0x7F,   // 
	0x80, 0x23,   // 
	0x80, 0x03,   // 

	0x80, 0x03,   // 
	0x80, 0x03,   // 
	0x80, 0x03,   // 
	0x80, 0x03,   // 

	0x80, 0x03,   // 
	0xC0, 0x01,   // 
	0xE0, 0x01,   // 
	0xF8, 0x01,   // 

	0xFC, 0x01,   // 
	0xFF, 0x01,   // 
	0xFF, 0xFF,   // 
	0xFF, 0xFF,   // 
};


BYTE XORmaskCursor[] = 
{ 
	0x00, 0x00,   // 
	0x06, 0x00,   // 
	0x1B, 0x00,   // 
	0x2D, 0x88,   // 

	0x36, 0xD8,   // 
	0x1B, 0x68,   //
	0x2D, 0xF8,   //
	0x37, 0xF8,   // 

	0x1B, 0xF8,   // 
	0x0F, 0xF8,   // 
	0x03, 0xFC,   // 
	0x01, 0xFC,   // 

	0x00, 0x7C,   // 
	0x00, 0x00,   // 
	0x00, 0x00,   // 
	0x00, 0x00,   // 
};
*/

BYTE ANDmaskCursor[] = 
{ 
        0xE9,0x3F,
        0xC0,0x1F,
        0x80,0xF,
        0x80,0x7,
        0x0,0x3,
        0x0,0x3,
        0x80,0x1,
        0xC0,0x1,
        0xC0,0x0,
        0x80,0x0,
        0x0,0x0,
        0x80,0x1,
        0xC0,0x3,
        0xF8,0x7,
        0xFF,0xEF,
        0xFF,0xFF,
};


BYTE XORmaskCursor[] = 
{ 
        0x16,0xC0,
        0x29,0x20,
        0x56,0xD0,
        0x5B,0x68,
        0xAD,0xB4,
        0xB7,0xF4,
        0x5B,0xFA,
        0x2F,0xFA,
        0x37,0xFD,
        0x43,0xFE,
        0xBF,0xFF,
        0x47,0xFE,
        0x38,0x1C,
        0x7,0xE8,
        0x0,0x10,
        0x0,0x0,
};


///////////////////
int start_cursor(
)
{
	//HINSTANCE hinst;            // handle to current instance  
 
	if (!hCurs3)
 		hCurs3 = CreateCursor( 0,   // app. instance 
             8,                // horizontal position of hot spot 
             8,                 // vertical position of hot spot 
             16,                // cursor width 
             16,                // cursor height 
             ANDmaskCursor,     // AND mask 
             XORmaskCursor );   // XOR mask 

	if (hCurs3)
		hCurs2 = SetCursor(hCurs3);

	return 0;
	
}

/////////////////////////////
int stop_cursor(
)
{
	if (!hCurs3) return 0;

	if (hCurs2) SetCursor(hCurs2);

	DestroyCursor(hCurs3);

	hCurs3 = NULL;

	return 0;
}



///////////////////////////////
Private void timerExpired(
)
{
	

	char cmd[50];
	char cmdvn[5];
	int	position = 0;
	
	mdlUndo_setViewUndoActive(view, TRUE);
	mdlView_synchWithTCB(view);

	
	if (iUpdate && iSendReset)
	{
		mdlWindow_cursorTurnOff();
		strcpy(cmd, "update ");
		sprintf(cmdvn, "%i", view+1);
		strcat(cmd, cmdvn);
		mdlInput_sendKeyin(cmd, 0, position++, 0);
	}	
	
	
	if ((iButton + 515) == TENTPNT && iSendReset && iReset) 
	{
		mdlWindow_cursorTurnOff();
		mdlInput_sendReset  ( 0 , 0 );
	}
		
	if (iFitAll >= 4 && iDblClick) 
	{
		strcpy(cmd, "fit view extended ");
		sprintf(cmdvn, "%i", view+1);
		strcat(cmd, cmdvn);
		mdlInput_sendKeyin(cmd, 0, position++, 0);
	
		mdlInput_sendReset (position++, NULL);
	}			
		
		
	iSendReset = 0;

}

///////////////////////////////
Private void timerExpired2(
)
{

	iFitAll = 0;
	iFitTimerOn = 0;

}


/////////////////////////////////////////
// CALLBACK
int  mesRecivied  ( 
Inputq_element  *queueElementP  
)
{ 
	


	if (queueElementP->u.rawButton.buttonNumber == (iButton + 515) &&
			queueElementP->u.rawButton.buttonTrans == BUTTONTRANS_DOWN)			
			{

			
				if (iFitAll == 0) 
				{
					mdlSystem_setTimerFunction  ( &timerHandleP2 , (int)(dDblClickTime*60.) , timerExpired2 , 0 , FALSE);  
					iFitAll++;
					iFitTimerOn = 1;
				}
				else
					if (iFitTimerOn) iFitAll++;
					
			
				iDown = 1;
				iMotionCount = 0;
				iSendReset = 0;
				
				spMouse.x = (long)	queueElementP->u.rawButton.scrnPoint.x;
				spMouse.y = (long)	queueElementP->u.rawButton.scrnPoint.y;
				
			}
	
	if (queueElementP->u.rawButton.buttonNumber == (iButton + 515) &&
			queueElementP->u.rawButton.buttonTrans == BUTTONTRANS_UP)
			{
				if (iFitTimerOn) iFitAll++;
					
				iDown = 0;
				iMotionCount = 0;
				
				if (iCursor) stop_cursor();		
						
				mdlSystem_setTimerFunction  ( &timerHandleP , 1 , timerExpired , 0 , FALSE);  
			}
	
		
	return INPUT_ACCEPT;
}


//////////////////////////
int  userView_motion ( 
MSWindow  *windowP,   // window we are in
int       xCoord,     // curretn x coord.
int       yCoord      // curretn y coord.
)
{
	
	Point2d spM;
	Point2d spOf;

	int v;

	if (mdlWindow_isView  ( &v , windowP ) == FALSE) return 0;

	
	if (iDown)
		iMotionCount++;
	else
	{
		view = v;
		return 0;
	}
	
	if (iMotionCount > (int)dDelay)
	{
		
		
		mdlView_synchWithTCB(view);
		mdlUndo_setViewUndoActive(view, FALSE);
			
			
		if (v != view)
		{
			iDown = 0;
			iMotionCount = 0;
			mdlWindow_cursorTurnOff ();
		}

		if (iKeepSel && mdlSelect_isActive())
		{
			ElementRef eref = NULL;
			DgnModelRefP mrP = NULL;
			if (mdlSelect_getElement(0, &eref, &mrP) == SUCCESS)
			{
				fp_sel = elementRef_getFilePos(eref);
			}
		}

		if (iCursor)
		{
			mdlWindow_cursorTurnOff ();
			start_cursor();
		}

		iSendReset = 1;
		
		spM.x = xCoord;
		spM.y = yCoord;

		spOf.x = spMouse.x - spM.x;
		spOf.y = spMouse.y - spM.y;

		//=============================
		mdlView_pan(&spOf, view, TRUE);
		//=============================
		
		spMouse.x = xCoord;
		spMouse.y = yCoord;
	
	}

	return 0;
}


///////////////////////////////////
Private void	dialogToolboxHook(
DialogMessage	*dmP	
)
{
	char sVar1[5];
	char sVar2[5];
	char sVar3[5];
	char sVar4[5];
	char sVar5[5];
	char sVar6[5];

    /* ignore any messages being sent to modal dialog hook */
    if (dmP->dialogId != DIALOGID_1)
			return;

    dmP->msgUnderstood = TRUE;
    
    switch (dmP->messageType)
	{
	case DIALOG_MESSAGE_INIT:
			{

			if (iUpdate)
			{
				iReset = -1;
				mdlDialog_itemSynch(dmP->db, 5);
				mdlDialog_itemSetEnabledState(dmP->db, 5, FALSE, TRUE);
			}
			
			break;
	    };		
	case DIALOG_MESSAGE_DESTROY:
	    {

			sprintf(sVar1, "%i", iButton);
			sprintf(sVar2, "%.0f", dDelay);
			sprintf(sVar3, "%i", iUpdate);
			sprintf(sVar4, "%i", iReset);
			sprintf(sVar5, "%i", iDblClick);
			sprintf(sVar6, "%.2f", dDblClickTime);
			

			mdlSystem_defineCfgVar(sNameNew, sVar1, CFGVAR_LEVEL_USER);
			mdlSystem_rewriteCfgVarFile(0, sNameNew, sVar1);			

			mdlSystem_defineCfgVar(sDelayNew, sVar2, CFGVAR_LEVEL_USER);
			mdlSystem_rewriteCfgVarFile(0, sDelayNew, sVar2);			
			
			mdlSystem_defineCfgVar(sUpdateNew, sVar3, CFGVAR_LEVEL_USER);
			mdlSystem_rewriteCfgVarFile(0, sUpdateNew, sVar3);			
			
			mdlSystem_defineCfgVar(sResetNew, sVar4, CFGVAR_LEVEL_USER);
			mdlSystem_rewriteCfgVarFile(0, sResetNew, sVar4);			

			mdlSystem_defineCfgVar(sDblClickNew, sVar5, CFGVAR_LEVEL_USER);
			mdlSystem_rewriteCfgVarFile(0, sDblClickNew, sVar5);			

			mdlSystem_defineCfgVar(sDblClickTimeNew, sVar6, CFGVAR_LEVEL_USER);
			mdlSystem_rewriteCfgVarFile(0, sDblClickTimeNew, sVar6);			



			break;
	    };

	default:
	    dmP->msgUnderstood = FALSE;
	    break;
	}
}


///////////////////
int getIntVar(int* iValP, char* sVarNameOld, char* sVarNameNew, char* sDefValue)
{

	char sVar[10];
	int res;

	if (sVarNameOld && mdlSystem_getCfgVar(sVar, sVarNameOld, 10) == SUCCESS)
	{
		*iValP = atoi(sVar);

		// delete old
		res = mdlSystem_deleteCfgVarAtLevel(sVarNameOld, CFGVAR_LEVEL_USER);
		mdlSystem_rewriteCfgVarFile(0, sVarNameOld, 0);

		// make new
		mdlSystem_defineCfgVar(sVarNameNew, sVar, CFGVAR_LEVEL_USER);
		mdlSystem_rewriteCfgVarFile(0, sVarNameNew, sVar);

	}
	else if (sVarNameNew && mdlSystem_getCfgVar(sVar, sVarNameNew, 10) == SUCCESS)
	{
		*iValP = atoi(sVar);
	}
	else if (sDefValue)
	{
		mdlSystem_defineCfgVar(sVarNameNew, sDefValue, CFGVAR_LEVEL_USER);
		mdlSystem_rewriteCfgVarFile(0, sVarNameNew, sDefValue);
	}

	return SUCCESS;

}


///////////////////
int getDblVar(double* dValP, char* sVarNameOld, char* sVarNameNew, char* sDefValue)
{

	char sVar[10];
	int res;

	//mdlSystem_enterDebug();

	if (mdlSystem_getCfgVar(sVar, sVarNameOld, 10) == SUCCESS)
	{
		*dValP = (double)atoi(sVar);

		// delete old
		res = mdlSystem_deleteCfgVarAtLevel(sVarNameOld, CFGVAR_LEVEL_USER);
		mdlSystem_rewriteCfgVarFile(0, sVarNameOld, 0);

		// make new
		mdlSystem_defineCfgVar(sVarNameNew, sVar, CFGVAR_LEVEL_USER);
		mdlSystem_rewriteCfgVarFile(0, sVarNameNew, sVar);

	}
	else if (mdlSystem_getCfgVar(sVar, sVarNameNew, 10) == SUCCESS)
	{
		*dValP = atof(sVar);
	}
	else
	{
		mdlSystem_defineCfgVar(sVarNameNew, sDefValue, CFGVAR_LEVEL_USER);
		mdlSystem_rewriteCfgVarFile(0, sVarNameNew, sDefValue);
	}

	return SUCCESS;

}




////////////////////////////////
Private void readSettings()
{

	getIntVar(&iButton, sName, sNameNew, "-1");
	getDblVar(&dDelay, sDelay, sDelayNew, "2");
	getDblVar(&dDblClickTime, sDblClickTime, sDblClickTimeNew, "0.5");
	getIntVar(&iUpdate, sUpdate, sUpdateNew, "0");
	getIntVar(&iReset, sReset, sResetNew, "1");
	getIntVar(&iDblClick, sDblClick, sDblClickNew, "0");
	getIntVar(&iKeepSel, NULL, sKeepSel, NULL);

}



/////////////////////////////////
extern "C" DLLEXPORT void cmdDialog(
char	*unparsedP
)
//cmdNumber   CMD_ACADPAN_DIALOG
{
	mdlDialog_open (NULL, DIALOGID_1);
}


/////////////////////////////////
extern "C" DLLEXPORT void cmdExit(
char	*unparsedP
)
//cmdNumber   CMD_ACADPAN_EXIT
{
	mdlDialog_cmdNumberQueue (FALSE, CMD_MDL_UNLOAD, mdlSystem_getCurrTaskID(), TRUE);
}



/////////////////////////////////
extern "C" DLLEXPORT void cmdAbout(
char	*unparsedP
)
//cmdNumber   CMD_ACADPAN_ABOUT
{

	char mes[2000];

	strcpy(mes, "AcadPan (UstnPan)\n");

	strcat(mes, "for MicroStation v8i (");
	strcat(mes, VERSION_STRING);
	strcat(mes, ")\n");

	strcat(mes, "Copyright 2006 - 2014 Leonid Wiebe, All Rights Reserved.\n");
	strcat(mes, "St.Petersburg, Russia, mailto:wleo@ya.ru\n\n");

	strcat(mes, "This program is free software: you can redistribute it and/or modify ");
	strcat(mes, "it under the terms of the GNU General Public License as published by ");
	strcat(mes, "the Free Software Foundation, either version 3 of the License, or ");
	strcat(mes, "(at your option) any later version.\n\n");

	strcat(mes, "This program is distributed in the hope that it will be useful, ");
	strcat(mes, "but WITHOUT ANY WARRANTY; without even the implied warranty of ");
	strcat(mes, "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the ");
	strcat(mes, "GNU General Public License for more details.");

	//strcat(mes, "\n\n");
	//strcat(mes, "You should have received a copy of the GNU General Public License ");
	//strcat(mes, "along with this program. If not, see http://www.gnu.org/licenses/.\n");



	mdlDialog_openMessageBox (DIALOGID_LargeInfoBox, mes, MSGBOX_ICON_INFORMATION);
}



/////////////////////////////////
extern "C" DLLEXPORT void cmdReadSettings(
char	*unparsedP
)
//cmdNumber   CMD_ACADPAN_READSETTINGS
{
	readSettings();
}



///////////////////////////
Private void dialogItemToggleHook(
DialogItemMessage   *dimP
)
{
	if (dimP->messageType == DITEM_MESSAGE_QUEUECOMMAND)
	{


		if (dimP->itemIndex == 4) 
		{
			if (iUpdate)
			{
				iReset = -1;
				mdlDialog_itemSynch(dimP->db, 5);
				mdlDialog_itemSetEnabledState(dimP->db, 5, FALSE, TRUE);
			}
			else
			{
				mdlDialog_itemSetEnabledState(dimP->db, 5, TRUE, TRUE);
			}
					
		}


	}

}


Private DialogHookInfo uHooks[] =
{
    {1,		(PFDialogHook)dialogToolboxHook},
    {2,		(PFDialogHook)dialogItemToggleHook},
};


//////////////////////////////////////////
StatusInt  callbackSelectUserFunction  ( 
SelectionSetAction*       action , 
UInt32       filePos , 
DgnModelRefP       modelRef  
)
{
	StatusInt ret = SUCCESS;

	if (iKeepSel && *action == SELECT_REMOVE && fp_sel > 0)
	{
		fp_sel = 0;
		ret = ERROR;
	}

	return ret;
}

////////////////////////////////////////////////
// M A I N
////////////////////////////////////////////////
extern "C" DLLEXPORT  int MdlMain
(
int         argc,
char        *argv[]
)
{	
	char sVar[10];
	RscFileHandle    rscFileH;	/* a resource file handle */

	SymbolSet*  setP;

		
	
	/* open the resource file that we came out of */
	mdlResource_openFile (&rscFileH, NULL, 0);
	

    static MdlCommandNumber cmdNumbers[] =
    {
		{cmdDialog,				CMD_ACADPAN_DIALOG			},
		{cmdAbout,  			CMD_ACADPAN_ABOUT			},
		{cmdReadSettings,  		CMD_ACADPAN_READSETTINGS	},
		{cmdExit,  				CMD_ACADPAN_EXIT			},
	};

	mdlSystem_registerCommandNumbers (cmdNumbers);


	mdlParse_loadCommandTable (NULL);

	setP = mdlCExpression_initializeSet (VISIBILITY_DIALOG_BOX, 0, FALSE);	
	mdlDialog_publishBasicVariable (setP, mdlCExpression_getType(TYPECODE_LONG), "iButton", &iButton);
	mdlDialog_publishBasicVariable (setP, mdlCExpression_getType(TYPECODE_DOUBLE), "dDelay", &dDelay);
	mdlDialog_publishBasicVariable (setP, mdlCExpression_getType(TYPECODE_DOUBLE), "dDblClickTime", &dDblClickTime);
	mdlDialog_publishBasicVariable (setP, mdlCExpression_getType(TYPECODE_LONG), "iUpdate", &iUpdate);
	mdlDialog_publishBasicVariable (setP, mdlCExpression_getType(TYPECODE_LONG), "iReset", &iReset);
	mdlDialog_publishBasicVariable (setP, mdlCExpression_getType(TYPECODE_LONG), "iDblClick", &iDblClick);


	if (mdlSystem_getCfgVar(sVar, "USTNPAN_CURSOR", 10) == SUCCESS)
		iCursor = atoi(sVar);


	mdlDialog_hookPublish (sizeof(uHooks)/sizeof(DialogHookInfo), uHooks);
	
	
    mdlInput_setMonitorFunction(MONITOR_ALL, mesRecivied);
    mdlView_setFunction(VIEW_MOTION, userView_motion);

	mdlLocate_setFunction (LOCATE_SELECT_CMD , callbackSelectUserFunction);


	readSettings();

    return SUCCESS;
}



